<template lang="pug">
.tools(
  :class="{ mobile: isMobile }"
  :style="style"
)
  .container
    .add-button.button.icon(
      v-if="isMobile"
      @click="$emit('add-clicked')"
    )
      .icon(v-html="$icons.plus")
    .button.icon(
      v-tooltip:bottom="'Undo'"
      :class="{ disabled: !undoStackSize }"
      @click="undo()"
    )
      .icon(v-html="$icons.undo")
    .button.icon(
      v-tooltip:bottom="'Redo'"
      @click="redo()"
      :class="{ disabled: !redoStackSize }"
    )
      .icon(v-html="$icons.redo")
    .menu-button.button.icon(
      @click.stop="showMenu = !showMenu"
      ref="menuButton"
    )
      .icon(v-html="$icons.dotsMenu")
      transition(name="scale-fade")
        .sub-menu(
          v-show="showMenu"
          ref="menu"
        )
          .sub-menu-row(@click="createNew()")
            .link Create new
          .sub-menu-row(
            v-if="isCollageIsMine"
            @click="duplicate()"
          )
            .link Duplicate
    .spacer
    .button.icon(
      v-tooltip:bottom="isHorizontal ? 'Set vertical layout' : 'Set horizontal layout'"
      v-if="!isMobile"
      @click="toggleLayout()"
    )
      .icon(
        v-html="$icons.rotate"
        style="padding-bottom: 7px"
      )
    .stage-sizes-container(v-if="!isMobile")
      stage-sizes-header
    .spacer
    .autosave-status(v-if="!isMobile") {{ autosaveStatusText }}
    .download
      .button(
        @click="$store.dispatch('rightSidebarShown', !rightSidebarShown)"
        ref="downloadWindowButton"
      ) {{ isMobile ? 'Share' : 'Export' }}
    .mobile(v-if="isMobile")
      .menu-button
        .button.icon(@click="$emit('mobile-menu-click')")
          .icon(v-html="$icons.menu")
    auth.auth(v-else)

  .error(:class="{ shown: error, hidden: !error }") {{ error }}
  .success(:class="{ shown: success, hidden: !success }") {{ success }}
</template>

<script>
import { mapState } from 'vuex'
import dataService from '../services/data'
import config from '../config'
import storeService from '../services/store'
import stageService from '../services/stage'

const height = config.toolsHeight

export default {
  name: 'Tools',
  data () {
    return {
      showMenu: false,
      isVertical: false,
      isCollageSaving: false,
      isCollageSaved: false,
      error: null,
      success: null,
      AUTOSAVE_STATUS_SAVING: dataService.AUTOSAVE_STATUS_SAVING,
      AUTOSAVE_STATUS_SAVED: dataService.AUTOSAVE_STATUS_SAVED,
      AUTOSAVE_STATUS_ERROR: dataService.AUTOSAVE_STATUS_ERROR,
      style: {
        height: height + 'px',
        'min-height': height + 'px'
      }
    }
  },
  computed: {
    ...mapState({
      undoStackSize: state => state.editor.undoStackSize,
      redoStackSize: state => state.editor.redoStackSize,
      activeItem: state => state.editor.activeItem,
      user: state => state.editor.user,
      userCollage: state => state.editor.userCollage,
      isMobile: state => state.editor.isMobile,
      isHorizontal: state => state.editor.stage.width > state.editor.stage.height,
      autosaveStatus: state => state.editor.autosave.status,
      isCollageIsMine: state => {
        return !!(
          state.editor.userCollage &&
          state.editor.userCollages.items.find(collage => collage.id === state.editor.userCollage.id)
        )
      },
      rightSidebarShown: state => state.editor.rightSidebarShown
    }),
    autosaveStatusText () {
      let autosaveStatusText = ''

      switch (this.autosaveStatus) {
        case dataService.AUTOSAVE_STATUS_SAVING:
          autosaveStatusText = 'Saving...'
          break
        case dataService.AUTOSAVE_STATUS_SAVED:
          autosaveStatusText = 'Saved'
          break
        case dataService.AUTOSAVE_STATUS_ERROR:
          autosaveStatusText = 'Not saved'
          break
      }

      return autosaveStatusText
    }
  },
  mounted () {
    document.addEventListener('mousedown', this.outsideClick)
  },
  destroyed () {
    document.removeEventListener('mousedown', this.outsideClick)
  },
  methods: {
    openMobileMenu () {
      this.$store.dispatch('setStageSizesShown', true)
    },
    createNew () {
      const newPath = '/creator/new'
      this.$router.push(newPath)
      if (this.$route.path === newPath) {
        this.$router.go(newPath)
      }
    },
    duplicate () {
      this.save(true)
    },
    update () {
      this.save()
    },
    save (duplicate = false) {
      this.isCollageSaved = false
      if (!this.isCollageSaving) {
        this.isCollageSaving = true
        let promise

        if (duplicate) {
          promise = dataService.duplicateCollage(this.userCollage)
        } else {
          promise = dataService.handleCollageSaving()
        }
        promise
          .then(() => {
            this.isCollageSaving = false
            this.isCollageSaved = true
            this.success = `Your collage has been ${duplicate ? 'duplicated' : 'saved'}!`
            setTimeout(() => {
              this.isCollageSaved = false
              this.success = null
            }, 2000)
          })
          .catch(() => {
            this.error = `We couldn't ${duplicate ? 'duplicate' : 'save'} collage. Please, try again later.`
            this.isCollageSaving = false
            setTimeout(() => { this.error = null }, 3000)
          })
      }
    },
    undo () {
      if (this.undoStackSize) {
        storeService.get('commandManager').undo()
      }
    },
    redo () {
      if (this.redoStackSize) {
        storeService.get('commandManager').redo()
      }
    },
    toggleRightSidebar () {
      storeService.get('rightSidebar').toggle()
    },
    toggleLayout () {
      stageService.rotate()
    },
    outsideClick (event) {
      if (this.$refs.menu && this.$refs.menuButton && !this.$refs.menu.contains(event.target) && !this.$refs.menuButton.contains(event.target)) {
        this.showMenu = false
      }
    }
  }
}
</script>

<style lang="scss" scoped>
  @import '../assets/css/mixins';
  @import '../assets/css/variables';
  @import '../assets/css/effects';

  .tools {
    width: 100%;
    position: relative;
    color: #fff;
    display: flex;
    z-index: 20;

    .auth {
      margin-left: 8px;
    }

    .container {
      background-color: $main-background;
      padding: 0 16px;
      width: 100%;
      align-items: center;
      display: flex;
      justify-content: left;
      flex-direction: row;
      z-index: 20;
      border-bottom: 1px solid rgba(255, 255, 255, 0.05);

      .add-button {
        width: 28px;
        height: 28px;
        background-color: #84C29D;
        border-radius: 50%;
      }

      .button {
        margin: 0 8px;

        &.icon {
          margin: 0 4px;
        }

        .icon {
          width: 32px;
          height: 32px;
        }
      }

      .menu-button {
        position: relative;

        .menu-icon {
          width: 10px;
          height: 15px;
          fill: #8c8c8c;
        }

        .sub-menu {
          left: -8px;
          color: #fff;
        }
      }

      .autosave-status {
        width: 70px;
        font-size: 14px;
        margin-right: 8px;
        text-align: right;
      }
    }

    .error, .success {
      position: absolute;
      z-index: 10;
      background-color: #ff3a3a;
      padding: 16px 0;
      border-radius: 100px;
      opacity: 0.9;
      white-space: nowrap;
      text-align: center;
      overflow: hidden;

      &.shown {
        opacity: 1;
        top: 72px;
        transition: top 0.3s, opacity 0.5s;
      }

      &.hidden {
        top: -72px;
        opacity: 0;
        transition: top 0.5s, opacity 0.3s;
      }
    }

    .error {
      width: 400px;
      left: calc(50% - 200px);
    }

    .success {
      width: 250px;
      left: calc(50% - 125px);
      background-color: #000;
    }

    &.mobile {
      .container {
        padding: 0 8px;
      }
    }
  }
</style>
